#!/bin/bash
KGL="src/kgl"
successes=0
failures=0
creates=0

Check_rec()
{
	fileName=$(basename $1 | cut -f 1 -d '.')

	eval "$KGL -c src/kgl_tmp.cc <$1 2>/dev/null"
	eval "g++ -std=c++0x src/kgl_tmp.cc > /dev/null 2>&1"
	if [ $? -ne 0 ] ; then
		expectedFail=$( echo $fileName | cut -f 1 -d '_')
		if [ "$expectedFail" == "x" ]; then
			successes=$((successes+1))
			echo "Success"
		else
			failures=$((failures+1))
			echo "Failed to compile"
		fi
	else
		eval "./a.out > output.txt"

		if [ -f "test_suite/outputs/$fileName.out"  ]; then
			eval "diff -B --strip-trailing-cr output.txt test_suite/outputs//$fileName.out >/dev/null" && isSame=1 || isSame=0
			if [ $isSame -eq 1 ]; then
				successes=$((successes+1))
				echo "Success"
			else
				echo "Failed should not happen"
				failures=$((failures+1))
			fi
		else
			eval "cp output.txt test_suite/outputs/$fileName.out"
			creates=$((creates+1))	
			echo "new output created"
		fi
	fi
}

Check()
{
	for test in $1;
	do
		if [ -f $test  ]; then
			echo "------------ $test ------------"
			Check_rec $test	
			eval "rm -f src/kgl_tmp.cc a.out"

		elif [ -d $test  ]; then
			append="/*"
			Check "$test$append" 
		fi
	done
}

getopts ":s:l:p" opt;
case $opt in
s)
	tests="test_suite/tests/semantic/*"
	;;
l) 
	tests="test_suite/tests/lexer/*"
   	;;
p)
	tests="test_suite/tests/parser/*"
	;;
*)
	tests="test_suite/tests/*"
	;;
esac

Check "$tests" "----------------"

echo "$successes passed"
echo "$failures failed"
echo "$creates file/s created"
